/*******************************************************************************
*                   Copyright (c) 1991-1994 Gemplus Development
*
* Name        : GemMulti.h
*
* Description : Layer which allows the use of different drivers at APDU level.
*
* Release     : 4.01.00
*
* Last Modif  : 28/03/95: V4.01.00
* Date        : 06/07/94: V4.00.00
*
********************************************************************************
*
* Warning     :
*
* Remark      :
*
*******************************************************************************/

/*------------------------------------------------------------------------------
Name definition:
   _GEMMULTI_H is used to avoid multiple inclusion.
------------------------------------------------------------------------------*/
#ifndef _GEMMULTI_H
#define _GEMMULTI_H

/*------------------------------------------------------------------------------
C++ Section:
------------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------------------------------------------
Prototype section
------------------------------------------------------------------------------*/

INT16 G_DECL G4_OpenChannel
(
   const G4_CHANNEL_PARAM G_FAR *Channel
);
INT16 G_DECL G4_CloseChannel
(
   const WORD16 ChannelNb
);
           
INT16 G_DECL G4_OpenSession
(
   const WORD16                  ChannelNb,
         G4_SESSION_PARAM G_FAR *Session
);
INT16 G_DECL G4_SwitchSession
(
   const WORD16                 ChannelNb,
         G4_SESSION_PARAM G_FAR *Session
);
INT16 G_DECL G4_CloseSession
(
   const WORD16 ChannelNb
);

INT16 G_DECL G4_ExchangeApdu
(
   const WORD16              ChannelNb,
         G4_APDU_COMM G_FAR *ApduComm,
         G4_APDU_RESP G_FAR *ApduResp
);

INT16 G_DECL G4_CmdGetTimeout
(
   const WORD16        ChannelNb, 
         WORD32 G_FAR *Time
);
INT16 G_DECL G4_CmdSetTimeout
(
   const WORD16 ChannelNb, 
   const WORD32 Time
);

INT16 G_DECL G4_ICCSetProtocol
(
   const WORD16        ChannelNb, 
   const char   G_FAR *ProtocolFile
);
INT16 G_DECL G4_ICCStatus
(
   const WORD16                  ChannelNb, 
         WORD16           G_FAR *Protocol,
         WORD32           G_FAR *BaudRate,
         G4_SESSION_PARAM G_FAR *Session
);
INT16 G_DECL G4_ICCDetection
(
   const WORD16         ChannelNb,
   const WORD16         Time,
   const INT16 (G_DECL *FnCheckIcc)(const BOOL),
   const HINSTANCE      hInst
);

INT16 G_DECL G4_IFDStatus
(
   const WORD16               ChannelNb,
         G4_IFD_STATUS G_FAR *Status
);
INT16 G_DECL G4_IFDDownload
(
   const WORD16        ChannelNb,
   const char   G_FAR *MemoryFile
);
INT16 G_DECL G4_IFDExchange
(
   const WORD16         ChannelNb,
   const WORD32         TimeOut,
   const WORD32         SendLength,
   const WORD8  G_HUGE *SendBuffer,
         WORD32 G_FAR  *ReadLength,
         WORD8  G_HUGE *ReadBuffer
);
INT16 G_DECL G4_IFDGetPowerTimeout
(
   const WORD16        ChannelNb, 
         WORD32 G_FAR *Time
);
INT16 G_DECL G4_IFDSetPowerTimeout
(
   const WORD16 ChannelNb, 
   const WORD32 Time
);

INT16 G_DECL G4_IFDDisplay
(
   const WORD16 ChannelNb,
   const WORD16 Value
);
INT16 G_DECL G4_IFDDisplayXY
(
   const WORD16 ChannelNb,
   const WORD16 Line,
   const WORD16 Column
);
INT16 G_DECL G4_IFDDisplayPrint
(
   const WORD16       ChannelNb,
   const char  G_FAR *String
);

INT16 G_DECL G4_IFDGetKey
(
   const WORD16        ChannelNb,
   const WORD16        Time,
   const BOOL          BeepAsked,
         WORD16 G_FAR *Line,
         WORD16 G_FAR *Column
);

INT16 G_DECL G4_IFDBeep
(
   const WORD16 ChannelNb,
   const WORD16 Time,
   const WORD32 Frequency
);

INT16 G_DECL G4_IFDRTCRead
(
   const WORD16        ChannelNb,
         WORD32 G_FAR *YyMmDd,
         WORD32 G_FAR *HhMmSs
);
INT16 G_DECL G4_IFDRTCWrite
(
   const WORD16 ChannelNb,
   const WORD32 YyMmDd,
   const WORD32 HhMmSs
);

INT16 G_DECL G4_GetErrorString
( 
   WORD16 G_FAR *RemainingLength,
   char   G_FAR *Message
);
void G_DECL G4_Gr40
(
   INT16 G_FAR *NameLength,
   char  G_FAR  Name[],
   INT16 G_FAR *ReleaseLength,
   char  G_FAR  Release[]
);

#ifdef __cplusplus
}
#endif

#endif
